Package org.python.core

# Class PySequenceList

java.lang.Object
org.python.core.PyObject
org.python.core.PySequence
org.python.core.PySequenceList

All Implemented Interfaces:
  `Serializable`, `Iterable`, `Collection`, `List`, `Traverseproc`

Direct Known Subclasses:
  `PyList`, `PyTuple`

public abstract class PySequenceList extends PySequence implements List, Traverseproc

See Also:
  - Serialized Form

## Nested Class Summary

## Nested classes/interfaces inherited from class org.python.core.PyObject

`PyObject.ConversionException`

## Field Summary

### Fields inherited from class org.python.core.PyObject

`gcMonitorGlobal, TYPE`

## Method Summary

Modifier and Type
Method
Description
`abstract void`
`add(int index, Object element)`
`abstract boolean`
`add(Object o)`
`abstract boolean`
`addAll(int index, Collection c)`
`abstract boolean`
`addAll(Collection c)`
`abstract void`
`clear()`
`abstract boolean`
`contains(Object o)`
`abstract boolean`
`containsAll(Collection c)`
`abstract boolean`
`equals(Object o)`
Should almost never be overridden.
`abstract Object`
`get(int index)`
`abstract PyObject[]`
`getArray()`
Get the backing array.
`abstract int`
`hashCode()`
`abstract int`
`indexOf(Object o)`
`abstract boolean`
`isEmpty()`
`abstract Iterator`
`iterator()`
`abstract int`
`lastIndexOf(Object o)`
`abstract ListIterator`
`listIterator()`
`abstract ListIterator`
`listIterator(int index)`
`abstract void`
`pyadd(int index, PyObject element)`
`abstract boolean`
`pyadd(PyObject o)`
`abstract PyObject`
`pyget(int index)`
`abstract void`
`pyset(int index, PyObject element)`
`boolean`
`refersDirectlyTo(PyObject ob)`
Optional operation.
`abstract Object`
`remove(int index)`
`abstract void`
`remove(int start, int stop)`
`abstract boolean`
`remove(Object o)`
`abstract boolean`
`removeAll(Collection c)`
`abstract boolean`
`retainAll(Collection c)`
`abstract Object`
`set(int index, Object element)`
`abstract int`
`size()`
`abstract List`
`subList(int fromIndex, int toIndex)`
`abstract Object[]`
`toArray()`
`abstract Object[]`
`toArray(Object[] a)`
`abstract String`
`toString()`
`int`
`traverse(Visitproc visit, Object arg)`
Traverses all directly contained `PyObject`s.

### Methods inherited from class org.python.core.PySequence

`__delitem__, __delslice__, __eq__, __finditem__, __finditem__, __ge__, __getitem__, __getslice__, __gt__, __iter__, __le__, __lt__, __ne__, __nonzero__, __setitem__, __setitem__, __setslice__, __tojava__, isMappingType, isNumberType, isSequenceType`

### Methods inherited from class org.python.core.PyObject

`__abs__, __add__, __and__, __call__, __call__, __call__, __call__, __call__, __call__, __call__, __call__, __call__, __call__, __call__, __call__, __call__, __call__, __call__, __call__, __cmp__, __coerce__, __coerce_ex__, __complex__, __contains__, __delattr__, __delattr__, __delete__, __delitem__, __delslice__, __dir__, __div__, __divmod__, __ensure_finalizer__, __findattr__, __findattr__, __findattr_ex__, __finditem__, __float__, __floordiv__, __format__, __get__, __getattr__, __getattr__, __getitem__, __getnewargs__, __getslice__, __hash__, __hex__, __iadd__, __iand__, __idiv__, __idivmod__, __ifloordiv__, __ilshift__, __imod__, __imul__, __index__, __int__, __invert__, __ior__, __ipow__, __irshift__, __isub__, __iternext__, __itruediv__, __ixor__, __len__, __long__, __lshift__, __mod__, __mul__, __neg__, __not__, __oct__, __or__, __pos__, __pow__, __pow__, __radd__, __rand__, __rdiv__, __rdivmod__, __reduce__, __reduce_ex__, __reduce_ex__, __repr__, __rfloordiv__, __rlshift__, __rmod__, __rmul__, __ror__, __rpow__, __rrshift__, __rshift__, __rsub__, __rtruediv__, __rxor__, __set__, __setattr__, __setattr__, __setitem__, __setslice__, __str__, __sub__, __truediv__, __trunc__, __unicode__, __xor__, _add, _and, _callextra, _cmp, _div, _divmod, _doget, _doget, _doset, _eq, _floordiv, _ge, _gt, _iadd, _iand, _idiv, _idivmod, _ifloordiv, _ilshift, _imod, _imul, _in, _ior, _ipow, _irshift, _is, _isnot, _isub, _itruediv, _ixor, _jcall, _jcallexc, _jthrow, _le, _lshift, _lt, _mod, _mul, _ne, _notin, _or, _pow, _rshift, _sub, _truediv, _xor, asDouble, asIndex, asIndex, asInt, asInt, asIterable, asLong, asLong, asName, asName, asString, asString, asStringOrNull, asStringOrNull, bit_length, conjugate, delDict, delType, dispatch__init__, fastGetClass, fastGetDict, getDict, getType, implementsDescrDelete, implementsDescrGet, implementsDescrSet, invoke, invoke, invoke, invoke, invoke, invoke, isCallable, isDataDescr, isIndex, isInteger, noAttributeError, object___subclasshook__, readonlyAttributeError, setDict, setType`

### Methods inherited from class java.lang.Object

`getClass, notify, notifyAll, wait, wait, wait`

### Methods inherited from interface java.util.Collection

`parallelStream, removeIf, stream, toArray`

### Methods inherited from interface java.lang.Iterable

`forEach`

### Methods inherited from interface java.util.List

`replaceAll, sort, spliterator`

## Method Details

### add

public abstract void add(int index, Object element)

Specified by:
  `add` in interface `List`

### add

public abstract boolean add(Object o)

Specified by:
  `add` in interface `Collection`
Specified by:
  `add` in interface `List`

### addAll

public abstract boolean addAll(int index, Collection c)

Specified by:
  `addAll` in interface `List`

### addAll

public abstract boolean addAll(Collection c)

Specified by:
  `addAll` in interface `Collection`
Specified by:
  `addAll` in interface `List`

### clear

public abstract void clear()

Specified by:
  `clear` in interface `Collection`
Specified by:
  `clear` in interface `List`

### contains

public abstract boolean contains(Object o)

Specified by:
  `contains` in interface `Collection`
Specified by:
  `contains` in interface `List`

### containsAll

public abstract boolean containsAll(Collection c)

Specified by:
  `containsAll` in interface `Collection`
Specified by:
  `containsAll` in interface `List`

### equals

public abstract boolean equals(Object o)
Description copied from class: `PyObject`
Should almost never be overridden. If overridden, it is the subclasses responsibility to ensure that `a.equals(b) == true` iff `cmp(a,b) == 0`

Specified by:
  `equals` in interface `Collection`
Specified by:
  `equals` in interface `List`
Overrides:
  `equals` in class `PyObject`

### get

public abstract Object get(int index)

Specified by:
  `get` in interface `List`

### getArray

public abstract PyObject[] getArray()
Get the backing array. The array should not be modified. To get a copy of the array, see `toArray()`.

### hashCode

public abstract int hashCode()

Specified by:
  `hashCode` in interface `Collection`
Specified by:
  `hashCode` in interface `List`
Overrides:
  `hashCode` in class `PyObject`

### indexOf

public abstract int indexOf(Object o)

Specified by:
  `indexOf` in interface `List`

### isEmpty

public abstract boolean isEmpty()

Specified by:
  `isEmpty` in interface `Collection`
Specified by:
  `isEmpty` in interface `List`

### iterator

public abstract Iterator iterator()

Specified by:
  `iterator` in interface `Collection`
Specified by:
  `iterator` in interface `Iterable`
Specified by:
  `iterator` in interface `List`

### lastIndexOf

public abstract int lastIndexOf(Object o)

Specified by:
  `lastIndexOf` in interface `List`

### listIterator

public abstract ListIterator listIterator()

Specified by:
  `listIterator` in interface `List`

### listIterator

public abstract ListIterator listIterator(int index)

Specified by:
  `listIterator` in interface `List`

### pyadd

public abstract void pyadd(int index, PyObject element)

### pyadd

public abstract boolean pyadd(PyObject o)

### pyget

public abstract PyObject pyget(int index)

### pyset

public abstract void pyset(int index, PyObject element)

### remove

public abstract Object remove(int index)

Specified by:
  `remove` in interface `List`

### remove

public abstract void remove(int start, int stop)

### remove

public abstract boolean remove(Object o)

Specified by:
  `remove` in interface `Collection`
Specified by:
  `remove` in interface `List`

### removeAll

public abstract boolean removeAll(Collection c)

Specified by:
  `removeAll` in interface `Collection`
Specified by:
  `removeAll` in interface `List`

### retainAll

public abstract boolean retainAll(Collection c)

Specified by:
  `retainAll` in interface `Collection`
Specified by:
  `retainAll` in interface `List`

### set

public abstract Object set(int index, Object element)

Specified by:
  `set` in interface `List`

### size

public abstract int size()

Specified by:
  `size` in interface `Collection`
Specified by:
  `size` in interface `List`

### subList

public abstract List subList(int fromIndex, int toIndex)

Specified by:
  `subList` in interface `List`

### toArray

public abstract Object[] toArray()

Specified by:
  `toArray` in interface `Collection`
Specified by:
  `toArray` in interface `List`

### toArray

public abstract Object[] toArray(Object[] a)

Specified by:
  `toArray` in interface `Collection`
Specified by:
  `toArray` in interface `List`

### toString

public abstract String toString()

Overrides:
  `toString` in class `PyObject`

### traverse

public int traverse(Visitproc visit, Object arg)
Description copied from interface: `Traverseproc`
Traverses all directly contained `PyObject`s. Like in CPython, `arg` must be passed unmodified to `visit` as its second parameter. If `Visitproc.visit(PyObject, Object)` returns nonzero, this return value must be returned immediately by traverse. `Visitproc.visit(PyObject, Object)` must not be called with a `null` PyObject-argument.

Specified by:
  `traverse` in interface `Traverseproc`

### refersDirectlyTo

public boolean refersDirectlyTo(PyObject ob) throws UnsupportedOperationException
Description copied from interface: `Traverseproc`
Optional operation. Should only be implemented if it is more efficient than calling `Traverseproc.traverse(Visitproc, Object)` with a visitproc that just watches out for `ob`. Must return `false` if `ob` is `null`.

Specified by:
  `refersDirectlyTo` in interface `Traverseproc`
Throws:
  `UnsupportedOperationException`